# Generated by Django 3.1.1 on 2020-09-24 10:57

from django.db import migrations, models

from arkindex.dataimport.models import WorkerVersionState


def update_invalid_workerversions(apps, schema_editor):
    WorkerVersion = apps.get_model('dataimport', 'WorkerVersion')
    WorkerVersion.objects \
        .filter(state=WorkerVersionState.Available, docker_image__isnull=True) \
        .update(state=WorkerVersionState.Error)


class Migration(migrations.Migration):

    dependencies = [
        ('dataimport', '0022_dataimport_load_children'),
    ]

    operations = [
        migrations.RunPython(
            update_invalid_workerversions,
            reverse_code=migrations.RunPython.noop,
            elidable=True,
        ),
        migrations.AddConstraint(
            model_name='workerversion',
            constraint=models.CheckConstraint(
                check=~models.Q(state=WorkerVersionState.Available, docker_image_id=None),
                name='workerversion_available_requires_docker_image'
            ),
        ),
    ]
