# Generated by Django 3.1.6 on 2021-02-24 10:38

from django.db import migrations
from enumfields import Enum


class OldDataImportMode(Enum):
    Elements = 'elements'


def remove_mode_elements(apps, schema_editor):
    DataImport = apps.get_model('dataimport', 'DataImport')
    DataImportElement = apps.get_model('dataimport', 'DataImportElement')

    # Switch the enum to restore Elements, because the EnumField would otherwise not let us filter
    DataImport.mode.field.enum = OldDataImportMode

    DataImportElement.objects.filter(dataimport__mode=OldDataImportMode.Elements).delete()
    DataImport.objects.filter(mode=OldDataImportMode.Elements).delete()


class Migration(migrations.Migration):

    dependencies = [
        ('dataimport', '0029_worker_activity'),
    ]

    operations = [
        migrations.RunPython(
            remove_mode_elements,
            reverse_code=migrations.RunPython.noop,
            elidable=True,
        )
    ]
