# Generated by Django 3.2.3 on 2021-08-31 07:53

import uuid

import django.db.models.deletion
from django.db import migrations, models


def rebuild_reminder(apps, schema_editor):
    """
    Print a reminder to rebuild the cache manually if there is anything in the database.
    """
    Corpus = apps.get_model('documents', 'Corpus')
    if Corpus.objects.exists():
        print("Please run `arkindex cache_worker_versions` to fill the corpus worker versions cache.")


class Migration(migrations.Migration):

    dependencies = [
        ('documents', '0042_transcription_entity_confidence'),
        ('dataimport', '0034_worker_run_config'),
    ]

    operations = [
        migrations.CreateModel(
            name='CorpusWorkerVersion',
            fields=[
                ('id', models.UUIDField(
                    default=uuid.uuid4,
                    editable=False,
                    primary_key=True,
                    serialize=False
                )),
                ('corpus', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='worker_version_cache',
                    to='documents.corpus',
                )),
                ('worker_version', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='corpus_cache',
                    to='dataimport.workerversion',
                )),
            ],
            options={
                'unique_together': {('corpus', 'worker_version')},
            },
        ),
        migrations.AddField(
            model_name='workerversion',
            name='corpora',
            field=models.ManyToManyField(
                related_name='worker_versions',
                through='dataimport.CorpusWorkerVersion',
                to='documents.Corpus',
            ),
        ),
        migrations.RunPython(
            code=rebuild_reminder,
            reverse_code=migrations.RunPython.noop,
        )
    ]
