# Generated by Django 3.2.5 on 2021-11-04 09:42

import uuid

import django.db.models.deletion
from django.db import migrations, models

import arkindex.project.fields


class Migration(migrations.Migration):

    dependencies = [
        ('dataimport', '0038_dataimport_use_gpu'),
    ]

    operations = [
        migrations.CreateModel(
            name='WorkerConfiguration',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=250)),
                ('configuration', models.JSONField(blank=True, default=dict)),
                ('configuration_hash', arkindex.project.fields.MD5HashField(max_length=32)),
            ],
        ),
        migrations.RemoveConstraint(
            model_name='workerrun',
            name='worker_run_configuration_objects',
        ),
        migrations.RenameField(
            model_name='workerrun',
            old_name='configuration',
            new_name='old_configuration',
        ),
        migrations.AddConstraint(
            model_name='workerrun',
            constraint=models.CheckConstraint(check=models.Q(('old_configuration__typeof', 'object')), name='worker_run_old_configuration_objects'),
        ),
        migrations.AddField(
            model_name='workerconfiguration',
            name='worker',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='configurations', to='dataimport.worker'),
        ),
        migrations.AddField(
            model_name='workeractivity',
            name='configuration',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='worker_activities', to='dataimport.workerconfiguration'),
        ),
        migrations.AddField(
            model_name='workerrun',
            name='configuration',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='worker_runs', to='dataimport.workerconfiguration'),
        ),
        migrations.AddConstraint(
            model_name='workerconfiguration',
            constraint=models.CheckConstraint(check=models.Q(('configuration__typeof', 'object')), name='worker_configuration_configuration_objects'),
        ),
        migrations.AlterUniqueTogether(
            name='workerconfiguration',
            unique_together={('worker', 'name'), ('worker', 'configuration_hash')},
        ),
    ]
