SELECT "documents_element"."id"
FROM "documents_element"
WHERE "documents_element"."id" IN
        (SELECT U0."path"[array_length(U0."path", 1)]
         FROM "documents_elementpath" U0
         WHERE U0."element_id" = '{source_id}'::uuid);

SAVEPOINT "{savepoints[0]}";

SELECT (1) AS "a"
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" = '{source_id}'::uuid
       AND "documents_elementpath"."path"[array_length("documents_elementpath"."path", 1)] = '{parent_id}'::uuid)
LIMIT 1;

SELECT (1) AS "a"
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" = '{source_id}'::uuid
       AND NOT ("documents_elementpath"."path"[array_length("documents_elementpath"."path", 1)] = '{parent_id}'::uuid))
LIMIT 1;

SELECT "documents_elementpath"."id",
       "documents_elementpath"."element_id",
       "documents_elementpath"."path",
       "documents_elementpath"."ordering"
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" IN
           (SELECT DISTINCT U0."id"
            FROM "documents_element" U0
            INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
            WHERE U1."path" @ > (ARRAY['{source_id}'::uuid])::uuid[])
       AND "documents_elementpath"."path" @ > (ARRAY['{parent_id}'::uuid])::uuid[]);

DELETE
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" IN
           (SELECT DISTINCT U0."id"
            FROM "documents_element" U0
            INNER JOIN "documents_elementpath" U1 ON (U0."id" = U1."element_id")
            WHERE U1."path" @ > (ARRAY['{source_id}'::uuid])::uuid[])
       AND "documents_elementpath"."path" @ > (ARRAY['{parent_id}'::uuid])::uuid[]);


DELETE
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" = '{source_id}'::uuid
       AND "documents_elementpath"."path" @ > (ARRAY['{parent_id}'::uuid])::uuid[]);

RELEASE SAVEPOINT "{savepoints[0]}";

SAVEPOINT "{savepoints[1]}";

SELECT "documents_elementpath"."element_id",
       "documents_elementpath"."path"
FROM "documents_elementpath"
WHERE "documents_elementpath"."element_id" IN ('{source_id}'::uuid,
                                               '{destination_id}'::uuid);

SELECT (MAX("documents_elementpath"."ordering") + 1) AS "max"
FROM "documents_elementpath"
INNER JOIN "documents_element" ON ("documents_elementpath"."element_id" = "documents_element"."id")
WHERE ("documents_element"."type_id" = '{page_type_id}'::uuid
       AND "documents_elementpath"."path"[array_length("documents_elementpath"."path", 1)] = '{destination_id}'::uuid
       AND "documents_elementpath"."path" && (ARRAY['{destination_id}'::uuid])::uuid[]);

SELECT "documents_elementpath"."id",
       "documents_elementpath"."element_id",
       "documents_elementpath"."path",
       "documents_elementpath"."ordering"
FROM "documents_elementpath"
WHERE "documents_elementpath"."path" @ > (ARRAY['{source_id}'::uuid])::uuid[];

INSERT INTO "documents_elementpath" ("id",
                                     "element_id",
                                     "path",
                                     "ordering")
VALUES ('{path_id}'::uuid, '{source_id}'::uuid, ARRAY['{destination_id}'::uuid]::uuid[], 3);

RELEASE SAVEPOINT "{savepoints[1]}"
