# Generated by Django 2.2.10 on 2020-04-30 10:56

import django.db.models.deletion
import enumfields.fields
from django.conf import settings
from django.db import migrations, models

from arkindex.users.models import Scope


def add_scopes(apps, schema_editor):
    db_alias = schema_editor.connection.alias
    User = apps.get_model('users', 'User')
    UserScope = apps.get_model('users', 'UserScope')
    UserScope.objects.using(db_alias).bulk_create([
        UserScope(user=user, scope=scope)
        for user in User.objects.using(db_alias).all()
        for scope in (Scope.CreateIIIFImage, Scope.UploadS3Image)
    ])


class Migration(migrations.Migration):

    dependencies = [
        ('users', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='UserScope',
            fields=[
                ('id', models.AutoField(
                    auto_created=True,
                    primary_key=True,
                    serialize=False,
                    verbose_name='ID',
                )),
                ('scope', enumfields.fields.EnumField(
                    enum=Scope,
                    max_length=50,
                )),
                ('user', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='user_scopes',
                    to=settings.AUTH_USER_MODEL,
                )),
            ],
            options={
                'unique_together': {('user', 'scope')},
            },
        ),
        migrations.RunPython(
            add_scopes,
            reverse_code=migrations.RunPython.noop,
        )
    ]
