# Generated by Django 2.2.13 on 2020-07-07 13:49

import django.db.models.deletion
from django.db import migrations, models

# Converts DataImport payloads to fields, from all the keys found in existing payloads:
# element_type → dataimport.element_type
# elt_type → dataimport.element_type
# folder_type → dataimport.folder_type
# element_id → dataimport.element
# folder_id → dataimport.element
# Many of those were not actually carried over by dataimport.0011.
# Ignored: corpus_id, ml_tools, pdf_engine, sha, repo_id

PAYLOAD_TO_FIELDS = """
UPDATE dataimport_dataimport di
    SET element_type_id = type.id
    FROM documents_elementtype type
    WHERE
        di.payload IS NOT NULL
        AND di.element_type_id IS NULL
        AND type.corpus_id = di.corpus_id
        AND type.slug = di.payload->>'element_type';

UPDATE dataimport_dataimport di
    SET element_type_id = type.id
    FROM documents_elementtype type
    WHERE
        di.payload IS NOT NULL
        AND di.element_type_id IS NULL
        AND type.corpus_id = di.corpus_id
        AND type.slug = di.payload->>'elt_type';

UPDATE dataimport_dataimport di
    SET folder_type_id = type.id
    FROM documents_elementtype type
    WHERE
        di.payload IS NOT NULL
        AND type.corpus_id = di.corpus_id
        AND type.slug = di.payload->>'folder_type';

UPDATE dataimport_dataimport di
    SET element_id = element.id
    FROM documents_element element
    WHERE
        di.payload IS NOT NULL
        AND di.element_id IS NULL
        AND element.corpus_id = di.corpus_id
        AND element.id = (di.payload->>'element_id')::uuid;

UPDATE dataimport_dataimport di
    SET element_id = element.id
    FROM documents_element element
    WHERE
        di.payload IS NOT NULL
        AND di.element_id IS NULL
        AND element.corpus_id = di.corpus_id
        AND element.id = (di.payload->>'folder_id')::uuid;
"""


class Migration(migrations.Migration):

    dependencies = [
        ('documents', '0017_remove_elementtype_default_view'),
        ('dataimport', '0014_dataimport_selection'),
    ]
    atomic = False

    operations = [
        migrations.AddField(
            model_name='dataimport',
            name='folder_type',
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name='folder_imports',
                to='documents.ElementType',
            ),
        ),
        migrations.AlterField(
            model_name='dataimport',
            name='element_type',
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name='element_imports',
                to='documents.ElementType',
            ),
        ),
        migrations.RunSQL(PAYLOAD_TO_FIELDS),
        migrations.RemoveField(
            model_name='dataimport',
            name='payload',
        ),
    ]
